---
title: HTMLInputElement.webkitEntries
slug: Web/API/HTMLInputElement/webkitEntries
tags:
  - API
  - File System API
  - File and Directory Entries API
  - Files
  - HTML DOM
  - HTMLInputElement
  - Non-standard
  - Property
  - webkitEntries
---
<p>{{APIRef("File System API")}}{{SeeCompatTable}}{{Non-standard_header}}</p>

<p><span class="seoSummary">The read-only <strong><code>webkitEntries</code></strong> property of the {{domxref("HTMLInputElement")}} interface contains an array of file system entries (as objects based on {{domxref("FileSystemEntry")}}) representing files and/or directories selected by the user using an {{HTMLElement("input")}} element of type <code>file</code>, but only if that selection was made using drag-and-drop: selecting a file in the dialog will leave the property empty (bug </span>1326031).</p>

<p>The array can only contain directories if the {{domxref("HTMLInputElement.webkitdirectory", "webkitdirectory")}} property is <code>true</code>. This means the <code>&lt;input&gt;</code> element was configured to let the user choose directories.</p>

<div class="note">
<p>This property is called <code>webkitEntries</code> in the specification due to its origins as a Google Chrome-specific API. It's likely to be renamed someday.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>entries</em> = <em>HTMLInputElement</em>.webkitEntries;</pre>

<h3 id="Value">Value</h3>

<p>An array of objects based on {{domxref("FileSystemEntry")}}, each representing one file which is selected in the {{HTMLElement("input")}} element. More specifically, files are represented by {{domxref("FileSystemFileEntry")}} objects, and, if they're allowed, directories are represented by {{domxref("FileSystemDirectoryEntry")}} objects.</p>

<h2 id="Example">Example</h2>

<p>This example shows how to create a file selection <code>&lt;input&gt;</code> element and process the selected files.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;input id="files" type="file" multiple&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">document.getElementById("files").addEventListener("change", function(event) {
  event.target.webkitEntries.forEach(function(entry) {
    /* do stuff with the entry */
  });
});
</pre>

<p>Each time a {{event("change")}} event occurs, this code iterates over the selected files, obtaining their {{domxref("FileSystemEntry")}}-based objects and acting on them.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('File System API', '#dom-htmlinputelement-webkitentries', 'webkitEntries') }}</td>
   <td>{{ Spec2('File System API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<p>This API has no official W3C or WHATWG specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLInputElement.webkitEntries")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
 <li>{{domxref("HTMLInputElement")}}</li>
 <li>{{domxref("FileSystemEntry")}}</li>
 <li>{{domxref("FileSystem")}}</li>
</ul>
